#ifndef _BatchedQueriesCullingManager_H__
#define _BatchedQueriesCullingManager_H__

#include "CoherentHierarchicalCullingManager.h"
#include "HierarchyInterface.h"


namespace GtpVisibility
{

/** Renders the scene with the coherent hierarchical culling algorithm. 
*/
class BatchedQueriesCullingManager : public CoherentHierarchicalCullingManager
{
public:
	BatchedQueriesCullingManager();
	/** Constructor taking the assumed visibility into account, i.e., the estimation
		for how many frames the current visibility is considered to be valid
	*/
	BatchedQueriesCullingManager(const unsigned int assumedVisibility);

	void RenderScene();
	
	void SetMaxPending(int maxPending);

protected:

	void IssueMultipleQueries(PendingQueue &pendingQueue, QueryQueue &queryQueue);

	/** maximal pending nodes.
	*/
	int mMaxPending;
};

} // namespace GtpVisibility

#endif // BatchedQueriesCullingManager_H
