#include "CullingManager.h"

namespace GtpVisibility {

//-----------------------------------------------------------------------
CullingManager::CullingManager():
mHierarchyInterface(NULL), mVisibilityThreshold(0), mNumQueryCulledNodes(0), 
mNumFrustumCulledNodes(0), mNumQueriesIssued(0),
mVisualizeCulledNodes(false)
{
}
//-----------------------------------------------------------------------
void CullingManager::SetHierarchyInterface(HierarchyInterface *hierarchyInterface)
{
	mHierarchyInterface = hierarchyInterface;
}
//-----------------------------------------------------------------------
void CullingManager::SetVisibilityThreshold(unsigned int visibilityThreshold)
{
	mVisibilityThreshold = visibilityThreshold;
}
//-----------------------------------------------------------------------
unsigned int CullingManager::GetNumFrustumCulledNodes()
{
	return mNumFrustumCulledNodes;
}
//-----------------------------------------------------------------------
unsigned int CullingManager::GetNumQueryCulledNodes()
{
	return mNumQueryCulledNodes;
}
//-----------------------------------------------------------------------
unsigned int CullingManager::GetNumQueriesIssued()
{
	return mNumQueriesIssued;
}
//-----------------------------------------------------------------------
void CullingManager::SetVisualizeCulledNodes(bool visualizeCulledNodes)
{
	mVisualizeCulledNodes = visualizeCulledNodes;
}
//-----------------------------------------------------------------------
void CullingManager::InitFrame(bool visualizeCulledNodes)
{
	mNumFrustumCulledNodes = mNumQueryCulledNodes = mNumQueriesIssued = 0;
	mVisualizeCulledNodes = visualizeCulledNodes;
}
} // namespace GtpVisibility
